<?php

namespace App\Exports;

use App\Models\UsersKPI;
use Maatwebsite\Excel\Concerns\FromCollection;
use Maatwebsite\Excel\Concerns\FromQuery;
use Maatwebsite\Excel\Concerns\WithHeadings;
use Maatwebsite\Excel\Concerns\WithMapping;

class MonthlyOperationExport implements WithMapping, WithHeadings,FromQuery
{
    public $_year,$_month;
    public function __construct($month,$year)
    {
        $this->_month=$month;
        $this->_year=$year;
    }

    public function query()
    {
        $year=$this->_year;
        $month=$this->_month;
        $users=UsersKPI::query()
        ->selectRaw("users_kpis.id,users.hr_id,
        users.name AS user_name,
        departments.title AS department,
        job_titles.title AS job_title,
        CONCAT(users_kpis.year,'-',users_kpis.month) AS `year_month`,
        users_kpis.total_employee_score,
        (SELECT FORMAT((SUM(users_kpis_questions.employee_actual)),2) FROM `users_kpis_questions` WHERE users_kpi_id=users_kpis.id AND kpi_id=users_kpis.kpi_id AND user_id=users_kpis.user_id AND kpi_question_question!='target' AND deleted_at IS NULL) AS total_employee_score_without_target,
     (SELECT CASE WHEN FORMAT((SUM(users_kpis_questions.employee_actual)),2) IS NULL THEN 0 ELSE FORMAT((SUM(users_kpis_questions.employee_actual)),2) END FROM `users_kpis_questions` WHERE users_kpi_id=users_kpis.id AND kpi_id=users_kpis.kpi_id AND user_id=users_kpis.user_id AND kpi_question_question='target' AND deleted_at IS NULL) AS total_employee_score_target_only,
    users_kpis.created_at")
            ->join('users','users.id','=','users_kpis.user_id')
            ->join('departments','departments.id','=','users.department_id')
            ->join('job_titles','job_titles.id','=','users.job_title_id')
            ->whereRaw("user_id IN(SELECT id FROM users WHERE users.department_id=3 AND deleted_at IS NULL) AND year='$year' AND month='$month' AND users_kpis.deleted_at IS NULL")
        ;
        if(request('IDS')){
            $users=$users->whereIn('id',explode(',',request('IDS')));
        }
//        die(getEloquentSqlWithBindings($users));
        return $users;
    }
    /**
     * @return \Illuminate\Support\Collection
     */

    public function map($user) : array {
        return [

            $user->id,
            $user->hr_id,
            $user->user_name,
            $user->department,
            $user->job_title,
            $user->year_month,
            $user->total_employee_score,
            $user->total_employee_score_without_target,
            $user->total_employee_score_target_only,
            $user->created_at,
        ] ;
    }
    public function headings() : array {
        return [
            __('ID'),
            __('HR ID'),
            __('Employee Name'),
            __('Department'),
            __('Job Titles'),
            __('Year Month'),
            __('Total Employee Score'),
            __('Total Employee Score Without target'),
            __('Total Employee Score Target Only'),
            __('Created At'),
        ] ;
    }
}
